"""Add visibility enum

Revision ID: 0dd75573c3da
Revises: 8fbeb080c434
Create Date: 2022-03-21 12:25:48.628523

"""

# revision identifiers, used by Alembic.
revision = '0dd75573c3da'
down_revision = '8fbeb080c434'

from alembic import op
import sqlalchemy as sa


def upgrade():
    op.execute("""
    UPDATE repository SET visibility = 'private' WHERE visibility = 'autocreated';

    CREATE TYPE visibility AS ENUM (
        'PUBLIC',
        'PRIVATE',
        'UNLISTED'
    );

    ALTER TABLE repository
    ALTER COLUMN visibility TYPE visibility USING upper(visibility)::visibility;
    """)


def downgrade():
    op.execute("""
    ALTER TABLE repository
    ALTER COLUMN visibility TYPE varchar USING lower(visibility::varchar);
    DROP TYPE visibility;
    """)
