"""Add SSH key table

Revision ID: 70bea64c0008
Revises: None
Create Date: 2019-04-18 15:29:25.388570

"""

# revision identifiers, used by Alembic.
revision = '70bea64c0008'
down_revision = None

from alembic import op
import sqlalchemy as sa


def upgrade():
    op.create_table('sshkey',
        sa.Column("id", sa.Integer, primary_key=True),
        sa.Column("user_id", sa.Integer, sa.ForeignKey('user.id'), nullable=False),
        sa.Column("meta_id", sa.Integer, nullable=False, unique=True, index=True),
        sa.Column("key", sa.String(4096), nullable=False, index=True),
        sa.Column("fingerprint", sa.String(512), nullable=False))


def downgrade():
    op.drop_table('sshkey')
