from srht.config import cfg
from srht.database import DbSession, db
if not hasattr(db, "session"):
    # Initialize the database if not already configured (for running daemon)
    db = DbSession(cfg("hg.sr.ht", "connection-string"))
    import hgsrht.types
    db.init()
from srht.webhook.celery import make_worker
from srht.metrics import RedisQueueCollector
from srht.webhook import Event
from srht.webhook.celery import CeleryWebhook
import sqlalchemy as sa

class UserWebhook(CeleryWebhook):
    events = [
        Event("repo:create", "info:read"),
        Event("repo:delete", "info:read"),
        Event("repo:update", "info:read"),
    ]

webhook_broker = cfg("hg.sr.ht", "webhooks")
worker = make_worker(broker=webhook_broker)
webhook_metrics_collector = RedisQueueCollector(webhook_broker, "webhooks", "Webhook queue length")
